import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Diese Klasse implementiert das Schaf. Das Schaf läuft in diesem Programm 
 * eine festgelegte Anzahl Schritte in eine Richtung, dreht sich und läuft 
 * dann wieder in eine neue Richtung. 
 */
public class Sheep extends Actor
{
    
    /**
     * Diese Klasse repräsentiert in späteren Versionen die Richtung in die das Schaf
     * läuft. 
     **/
    public static class Direction 
    { 
        // Das Schaf hat keine eigene Richtung
    }
    
    /**
     * Konstruktor
     */
    public Sheep()
    {
        // Schaf Konstruktor
    }

    /**
     * In jedem Schritt der Simulation wird die Methode "act()" aufgerufen.
     * Dies heisst, dass alle Funktionen in dieser Methode einmal pro Schritt
     * aufgerufen werden
     * 
     * In diesem Beispiel bewegt sich das Schaf in eine Richtung, überprüft,
     * obe es Gras an der neuen Position gibt und isst dann das Gras. 
     */
    public void act()
    {
        // Erhalte eine Referenz zu dem Feld auf dem das Schaf lebt.
        Field theField = getWorld();

        // Deklariert die aktuelle Postion des Schafs mit einer Methode, die
        // die X bzw. Y Koordinate des Schafes an seiner aktuellen Position zurückgibt.
        int oldX = getX();
        int oldY = getY();
        
        // Setzt die neuen Koordinaten des Schafes auf eine neue Position auf 
        // der x-y-Koordinate.
        int newX = oldX + 0;
        int newY = oldY + 0;

        /** 
         * Diese Funktion (If-Statement) ruft die Methode 
         * hasGrassAt(int, int) in der Welt bzw. in der Klasse "Field" auf.
         * 
         * Wenn es ein Gras auf dem neuen Feld hat, dann isst es das Grass.
         * Anschliessend bewegt sich das Schaf an die neue Position.
         */
        if(theField.hasGrassAt(newX, newY))
        {
           // Iss das Grass auf dem neuen Feld.
           theField.eatGrassAt(newX, newY); 
           // Bewege das Schaf zur neuen Position
           setLocation(newX, newY);
        } /** else if (theField.hasBrickAt(newX, newY))
        {
           //Deine Lösung für die Bewegung des Schafes, wenn es auf eine Mauer stehen
           //würde im nächsten Schritt.
           setLocation(Variable für X, Variable für Y);
           
        } **/ else
        {
           // Bewege das Schaf zur neuen Position 
           setLocation(newX, newY);
        }
    } // end von act()
 
    /**
     * Diese Funktion gibt infos zurück an die Klasse Welt. Hier muss man
     * nichts ändern.
     **/
    public Field getWorld()
    {
        return (Field)super.getWorld();
    }
    
   
    /** 
     * Diese Methode gibt eine zufällige Zahl zwischen zwei angegebenen Werten zurück.
     */
    public int getRandomNumber(int start,int end)
    {
       int normal = Greenfoot.getRandomNumber(end-start+1);
       return normal+start;
    }
}
